Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::XMSS_WOTS_PrivateKey Class Referencefinal

`#include <xmss_wots_privatekey.h>`

Inheritance diagram for Botan::XMSS_WOTS_PrivateKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
wots_keysig_t | at (size_t i, XMSS_Hash &hash)
wots_keysig_t | at (const XMSS_Address &adrs, XMSS_Hash &hash)
bool | check_key (RandomNumberGenerator &, bool) const override
virtual std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
wots_keysig_t | generate_private_key (const secure_vector< uint8_t > &priv_seed)
XMSS_WOTS_PublicKey | generate_public_key (XMSS_Address &adrs)
void | generate_public_key (XMSS_WOTS_PublicKey &pub_key, wots_keysig_t &&in_key_data, XMSS_Address &adrs, XMSS_Hash &hash)
void | generate_public_key (XMSS_WOTS_PublicKey &pub_key, wots_keysig_t &&in_key_data, XMSS_Address &adrs)
virtual OID | get_oid () const
const wots_keysig_t & | key_data () const
wots_keysig_t & | key_data ()
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
| operator const wots_keysig_t & () const
| operator wots_keysig_t & ()
bool | operator!= (const XMSS_WOTS_PublicKey &key)
bool | operator== (const XMSS_WOTS_PublicKey &key)
wots_keysig_t | operator[] (size_t i)
wots_keysig_t | operator[] (const XMSS_Address &adrs)
const secure_vector< uint8_t > & | operator[] (size_t i) const
AlgorithmIdentifier | pkcs8_algorithm_identifier () const override
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
const secure_vector< uint8_t > & | private_seed () const
std::vector< uint8_t > | public_key_bits () const override
const secure_vector< uint8_t > & | public_seed () const
secure_vector< uint8_t > & | public_seed ()
void | set_key_data (const wots_keysig_t &key_data)
void | set_key_data (wots_keysig_t &&key_data)
void | set_private_seed (const secure_vector< uint8_t > &private_seed)
void | set_private_seed (secure_vector< uint8_t > &&private_seed)
void | set_public_seed (const secure_vector< uint8_t > &public_seed)
void | set_public_seed (secure_vector< uint8_t > &&public_seed)
wots_keysig_t | sign (const secure_vector< uint8_t > &msg, XMSS_Address &adrs)
wots_keysig_t | sign (const secure_vector< uint8_t > &msg, XMSS_Address &adrs, XMSS_Hash &hash)
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const
const XMSS_WOTS_Parameters & | wots_parameters () const
| XMSS_WOTS_PrivateKey (XMSS_WOTS_Parameters::ots_algorithm_t oid)
| XMSS_WOTS_PrivateKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, RandomNumberGenerator &rng)
| XMSS_WOTS_PrivateKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, const secure_vector< uint8_t > &public_seed, RandomNumberGenerator &rng)
| XMSS_WOTS_PrivateKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, const secure_vector< uint8_t > &public_seed)
| XMSS_WOTS_PrivateKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, const secure_vector< uint8_t > &public_seed, const secure_vector< uint8_t > &private_seed)

## Protected Member Functions
void | chain (secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed, XMSS_Hash &hash)
void | chain (secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed)

## Protected Attributes
XMSS_Hash | m_hash
wots_keysig_t | m_key
secure_vector< uint8_t > | m_public_seed
XMSS_WOTS_Parameters | m_wots_params

## Detailed Description

A Winternitz One Time Signature private key for use with Extended Hash-Based Signatures.

Definition at line 26 of file xmss_wots_privatekey.h.

## Constructor & Destructor Documentation

Botan::XMSS_WOTS_PrivateKey::XMSS_WOTS_PrivateKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid | ) |
| inline

Creates a WOTS private key for the chosen XMSS WOTS signature method. Members need to be initialized manually.

Parameters

  oid | Identifier for the selected signature method.

Definition at line 36 of file xmss_wots_privatekey.h.

37 : XMSS_WOTS_PublicKey(oid)
38 {}
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84

Botan::XMSS_WOTS_PrivateKey::XMSS_WOTS_PrivateKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | RandomNumberGenerator & | rng
| ) |  |
| inline

Creates a WOTS private key for the chosen XMSS WOTS signature method.

Parameters

  oid | Identifier for the selected signature method.
  rng | A random number generator to use for key generation.

Definition at line 46 of file xmss_wots_privatekey.h.

References Botan::XMSS_WOTS_PublicKey::set_key_data().

48 : XMSS_WOTS_PublicKey(oid, rng),
49 m_private_seed(rng.random_vec(m_wots_params.element_size()))
50 {
51 set_key_data(generate(m_private_seed));
52 }
Botan::XMSS_WOTS_Parameters::element_size
size_t element_size() const
Definition: xmss_wots_parameters.h:79
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84
Botan::XMSS_WOTS_PublicKey::set_key_data
void set_key_data(const wots_keysig_t &key_data)
Definition: xmss_wots_publickey.h:219
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

Botan::XMSS_WOTS_PrivateKey::XMSS_WOTS_PrivateKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | const secure_vector< uint8_t > & | public_seed,
|  | RandomNumberGenerator & | rng
| ) |  |
| inline

Constructs a WOTS private key. Chains will be generated on demand applying a hash function to a unique value generated from a secret seed and a counter. The secret seed of length n, will be automatically generated using AutoSeeded_RNG(). "n" equals the element size of the chosen WOTS security parameter set.

Parameters

  oid | Identifier for the selected signature method.
  public_seed | A public seed used for the pseudo random generation of public keys derived from this private key.
  rng | A random number generator to use for key generation.

Definition at line 66 of file xmss_wots_privatekey.h.

References Botan::XMSS_WOTS_PublicKey::set_key_data().

69 : XMSS_WOTS_PublicKey(oid, public_seed),
70 m_private_seed(rng.random_vec(m_wots_params.element_size()))
71 {
72 set_key_data(generate(m_private_seed));
73 }
Botan::XMSS_WOTS_Parameters::element_size
size_t element_size() const
Definition: xmss_wots_parameters.h:79
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84
Botan::XMSS_WOTS_PublicKey::set_key_data
void set_key_data(const wots_keysig_t &key_data)
Definition: xmss_wots_publickey.h:219
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

Botan::XMSS_WOTS_PrivateKey::XMSS_WOTS_PrivateKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | const secure_vector< uint8_t > & | public_seed
| ) |  |
| inline

Constructs a WOTS private key. Chains will be generated on demand applying a hash function to a unique value generated from a secret seed and a counter. The secret seed of length n, will be automatically generated using AutoSeeded_RNG(). "n" equals the element size of the chosen WOTS security parameter set.

Parameters

  oid | Identifier for the selected signature method.
  public_seed | A public seed used for the pseudo random generation of public keys derived from this private key.

Definition at line 86 of file xmss_wots_privatekey.h.

88 : XMSS_WOTS_PublicKey(oid, public_seed)
89 {}
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84

Botan::XMSS_WOTS_PrivateKey::XMSS_WOTS_PrivateKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | const secure_vector< uint8_t > & | public_seed,
|  | const secure_vector< uint8_t > & | private_seed
| ) |  |
| inline

Constructs a WOTS private key. Chains will be generated on demand applying a hash function to a unique value generated from the secret seed and a counter.

Parameters

  oid | Identifier for the selected signature method.
  public_seed | A public seed used for the pseudo random generation of public keys derived from this private key.
  private_seed | A secret uniformly random n-byte value.

Definition at line 101 of file xmss_wots_privatekey.h.

References Botan::XMSS_WOTS_PublicKey::set_key_data().

104 : XMSS_WOTS_PublicKey(oid, public_seed),
105 m_private_seed(private_seed)
106 {
107 set_key_data(generate(private_seed));
108 }
Botan::XMSS_WOTS_PrivateKey::private_seed
const secure_vector< uint8_t > & private_seed() const
Definition: xmss_wots_privatekey.h:268
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84
Botan::XMSS_WOTS_PublicKey::set_key_data
void set_key_data(const wots_keysig_t &key_data)
Definition: xmss_wots_publickey.h:219

## Member Function Documentation

std::string Botan::XMSS_WOTS_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 234 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_wots_params, and Botan::XMSS_WOTS_Parameters::name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::algo_name().

235 {
236 return m_wots_params.name();
237 }
Botan::XMSS_WOTS_Parameters::name
const std::string & name() const
Definition: xmss_wots_parameters.h:59
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

AlgorithmIdentifier Botan::XMSS_WOTS_PublicKey::algorithm_identifier | ( |  | ) | const
| inline override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 239 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier().

240 {
241 throw Not_Implemented("No AlgorithmIdentifier available for XMSS-WOTS.");
242 }

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::at | ( | size_t | i,
|  | XMSS_Hash & | hash
| ) |  |
| inline

Retrieves the i-th WOTS private key using pseudo random key (re-)generation.

This overload is used in multithreaded scenarios, where it is required to provide seperate instances of XMSS_Hash to each thread.

Parameters

  i | Index of the key to retrieve.
  hash | Instance of XMSS_Hash, that may only be used by the thead executing at.

Returns
  WOTS secret key.

Definition at line 124 of file xmss_wots_privatekey.h.

References Botan::XMSS_Tools::concat(), Botan::XMSS_WOTS_Parameters::element_size(), Botan::XMSS_Hash::h(), and Botan::XMSS_WOTS_PublicKey::m_wots_params.

Referenced by operator[](), and sign().

125 {
126 secure_vector<uint8_t> idx_bytes;
127 XMSS_Tools::concat(idx_bytes, i, m_wots_params.element_size());
128 hash.h(idx_bytes, m_private_seed, idx_bytes);
129 return generate(idx_bytes, hash);
130 }
Botan::XMSS_WOTS_Parameters::element_size
size_t element_size() const
Definition: xmss_wots_parameters.h:79
Botan::XMSS_Tools::concat
static void concat(secure_vector< uint8_t > &target, const T &src)
Definition: xmss_tools.h:63
hash
MechanismType hash
Definition: p11_mechanism.cpp:64
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::at | ( | const XMSS_Address & | adrs,
|  | XMSS_Hash & | hash
| ) |  |
| inline

Retrieves the i-th WOTS private key using pseudo random key (re-)generation.

This overload is used in multithreaded scenarios, where it is required to provide seperate instances of XMSS_Hash to each thread.

Parameters

  adrs | The address of the key to retrieve.
  hash | Instance of XMSS_Hash, that may only be used by the thead executing at.

Returns
  WOTS secret key.

Definition at line 159 of file xmss_wots_privatekey.h.

References Botan::XMSS_Address::bytes(), and Botan::XMSS_Hash::prf().

160 {
161 secure_vector<uint8_t> result;
162 hash.prf(result, m_private_seed, adrs.bytes());
163 return generate(result, hash);
164 }
hash
MechanismType hash
Definition: p11_mechanism.cpp:64

void Botan::XMSS_WOTS_PublicKey::chain | ( | secure_vector< uint8_t > & | x,
|  | size_t | start_idx,
|  | size_t | steps,
|  | XMSS_Address & | adrs,
|  | const secure_vector< uint8_t > & | public_seed,
|  | XMSS_Hash & | hash
| ) |  |
| protected inherited

Algorithm 2: Chaining Function.

Takes an n-byte input string and transforms it into a the function result iterating the cryptographic hash function "F" steps times on the input x using the outputs of the PRNG "G".

This overload is used in multithreaded scenarios, where it is required to provide seperate instances of XMSS_Hash to each thread.

Parameters

  [out] | x | An n-byte input string, that will be transformed into the chaining function result.
  | start_idx | The start index.
  | steps | A number of steps.
  | adrs | An OTS Hash Address.
  | public_seed | A public seed.
  | hash | Instance of XMSS_Hash, that may only by the thead executing chain.

Definition at line 16 of file xmss_wots_publickey.cpp.

References Botan::XMSS_Address::bytes(), Botan::XMSS_Hash::f(), Botan::XMSS_Address::Key_Mode, Botan::XMSS_WOTS_PublicKey::m_wots_params, Botan::XMSS_Address::Mask_Mode, Botan::XMSS_Hash::output_length(), Botan::XMSS_Hash::prf(), Botan::XMSS_Address::set_hash_address(), Botan::XMSS_Address::set_key_mask_mode(), Botan::XMSS_WOTS_Parameters::wots_parameter(), and Botan::xor_buf().

Referenced by Botan::XMSS_WOTS_PublicKey::chain(), generate_public_key(), and sign().

22 {
23 secure_vector<uint8_t> prf_output(hash.output_length());
24
25 for(size_t i = start_idx;
26 i < (start_idx + steps) && i < m_wots_params.wots_parameter();
27 i++)
28 {
29 adrs.set_hash_address(static_cast<uint32_t>(i));
30
31 //Calculate tmp XOR bitmask
32 adrs.set_key_mask_mode(XMSS_Address::Key_Mask::Mask_Mode);
33 hash.prf(prf_output, seed, adrs.bytes());
34 xor_buf(result, prf_output, result.size());
35
36 // Calculate key
37 adrs.set_key_mask_mode(XMSS_Address::Key_Mask::Key_Mode);
38
39 //Calculate f(key, tmp XOR bitmask)
40 hash.prf(prf_output, seed, adrs.bytes());
41 hash.f(result, prf_output, result);
42 }
43 }
Botan::xor_buf
void xor_buf(uint8_t out[], const uint8_t in[], size_t length)
Definition: mem_ops.h:232
Botan::XMSS_WOTS_Parameters::wots_parameter
size_t wots_parameter() const
Definition: xmss_wots_parameters.h:87
Botan::XMSS_Address::Key_Mask::Mask_Mode
hash
MechanismType hash
Definition: p11_mechanism.cpp:64
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325
Botan::XMSS_Address::Key_Mask::Key_Mode

void Botan::XMSS_WOTS_PublicKey::chain | ( | secure_vector< uint8_t > & | x,
|  | size_t | start_idx,
|  | size_t | steps,
|  | XMSS_Address & | adrs,
|  | const secure_vector< uint8_t > & | public_seed
| ) |  |
| inline protected inherited

Algorithm 2: Chaining Function.

Takes an n-byte input string and transforms it into a the function result iterating the cryptographic hash function "F" steps times on the input x using the outputs of the PRNG "G".

Parameters

  [out] | x | An n-byte input string, that will be transformed into the chaining function result.
  | start_idx | The start index.
  | steps | A number of steps.
  | adrs | An OTS Hash Address.
  | public_seed | A public seed.

Definition at line 316 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::chain(), and Botan::XMSS_WOTS_PublicKey::m_hash.

321 {
322 chain(x, start_idx, steps, adrs, public_seed, m_hash);
323 }
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::chain
void chain(secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed, XMSS_Hash &hash)
Definition: xmss_wots_publickey.cpp:16
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:326

bool Botan::XMSS_WOTS_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual inherited

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 244 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::check_key().

245 {
246 return true;
247 }

std::unique_ptr< PK_Ops::Decryption > Botan::Private_Key::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, Botan::SM2_PrivateKey, and Botan::ElGamal_PrivateKey.

Definition at line 114 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Decryptor_EME::PK_Decryptor_EME().

117 {
118 throw Lookup_Error(algo_name() + " does not support decryption");
119 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 91 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, and Botan::McEliece_PrivateKey.

Definition at line 122 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

125 {
126 throw Lookup_Error(algo_name() + " does not support KEM decryption");
127 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 99 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ECDH_PrivateKey, Botan::Curve25519_PrivateKey, and Botan::DH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Signature > Botan::Private_Key::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PrivateKey, Botan::TPM_PrivateKey, Botan::RSA_PrivateKey, Botan::ECDSA_PrivateKey, Botan::GOST_3410_PrivateKey, Botan::SM2_PrivateKey, Botan::ECGDSA_PrivateKey, Botan::ECKCDSA_PrivateKey, Botan::Ed25519_PrivateKey, and Botan::DSA_PrivateKey.

Definition at line 130 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Signer::PK_Signer().

133 {
134 throw Lookup_Error(algo_name() + " does not support signatures");
135 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PublicKey, Botan::RSA_PublicKey, Botan::ECDSA_PublicKey, Botan::XMSS_WOTS_Addressed_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::SM2_PublicKey, Botan::Ed25519_PublicKey, and Botan::DSA_PublicKey.

Definition at line 107 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), and Botan::PK_Verifier::PK_Verifier().

109 {
110 throw Lookup_Error(algo_name() + " does not support verification");
111 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 126 of file pk_keys.h.

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

127 {
128 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
129 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:113
Botan::IEEE_1363
Definition: pk_keys.h:24
Botan::DER_SEQUENCE
Definition: pk_keys.h:24

size_t Botan::XMSS_WOTS_PublicKey::estimated_strength | ( |  | ) | const
| inline override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 249 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_Parameters::estimated_strength(), and Botan::XMSS_WOTS_PublicKey::m_wots_params.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength(), and Botan::XMSS_WOTS_Addressed_PublicKey::key_length().

250 {
251 return m_wots_params.estimated_strength();
252 }
Botan::XMSS_WOTS_Parameters::estimated_strength
size_t estimated_strength() const
Definition: xmss_wots_parameters.h:99
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 216 of file pk_keys.h.

217 {
218 return fingerprint_private(alg); // match behavior in previous versions
219 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

References Botan::create_hex_fingerprint(), and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

References Botan::create_hex_fingerprint(), and Botan::Public_Key::subject_public_key().

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::generate_private_key | ( | const secure_vector< uint8_t > & | priv_seed | ) |

XMSS_WOTS_PublicKey Botan::XMSS_WOTS_PrivateKey::generate_public_key | ( | XMSS_Address & | adrs | ) |

Algorithm 4: "WOTS_genPK" Generates a Winternitz One Time Signature+ (WOTS+) Public Key from a given private key.

Parameters

  adrs | Hash function address encoding the address of the WOTS+ key pair within a greater structure.

Returns
  A XMSS_WOTS_PublicKey.

Definition at line 32 of file xmss_wots_privatekey.cpp.

References Botan::XMSS_WOTS_PublicKey::m_wots_params, Botan::XMSS_WOTS_Parameters::oid(), and Botan::XMSS_WOTS_PublicKey::public_seed().

Referenced by generate_public_key().

33 {
34 XMSS_WOTS_PublicKey pub_key(m_wots_params.oid(),
35 public_seed());
36 generate_public_key(pub_key, wots_keysig_t((*this)[adrs]), adrs);
37 return pub_key;
38 }
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey
XMSS_WOTS_PublicKey(XMSS_WOTS_Parameters::ots_algorithm_t oid)
Definition: xmss_wots_publickey.h:84
Botan::XMSS_WOTS_PrivateKey::generate_public_key
XMSS_WOTS_PublicKey generate_public_key(XMSS_Address &adrs)
Definition: xmss_wots_privatekey.cpp:32
Botan::wots_keysig_t
std::vector< secure_vector< uint8_t > > wots_keysig_t
Definition: xmss_common_ops.h:21
Botan::XMSS_WOTS_Parameters::oid
ots_algorithm_t oid() const
Definition: xmss_wots_parameters.h:97
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

void Botan::XMSS_WOTS_PrivateKey::generate_public_key | ( | XMSS_WOTS_PublicKey & | pub_key,
|  | wots_keysig_t && | in_key_data,
|  | XMSS_Address & | adrs,
|  | XMSS_Hash & | hash
| ) |  |

Algorithm 4: "WOTS_genPK" Initializes a Winternitz One Time Signature+ (WOTS+) Public Key's key_data() member, with data derived from in_key_data using the WOTS chaining function.

This overload is used in multithreaded scenarios, where it is required to provide seperate instances of XMSS_Hash to each thread.

Parameters

  [out] | pub_key | Public key to initialize key_data() member on.
  | in_key_data | Input key material from private key used for public key generation.
  | adrs | Hash function address encoding the address of the WOTS+ key pair within a greater structure.
  | hash | Instance of XMSS_Hash, that may only by the thead executing generate_public_key.

Definition at line 41 of file xmss_wots_privatekey.cpp.

References BOTAN_ASSERT, Botan::XMSS_WOTS_PublicKey::chain(), hash, Botan::XMSS_WOTS_Parameters::len(), Botan::XMSS_WOTS_PublicKey::m_wots_params, Botan::XMSS_WOTS_PublicKey::public_seed(), Botan::XMSS_Address::set_chain_address(), Botan::XMSS_WOTS_PublicKey::set_key_data(), Botan::XMSS_WOTS_Parameters::wots_parameter(), and Botan::XMSS_WOTS_PublicKey::wots_parameters().

45 {
46 BOTAN_ASSERT(wots_parameters() == pub_key.wots_parameters() &&
47 public_seed() == pub_key.public_seed(),
48 "Conflicting public key data.");
49
50 pub_key.set_key_data(std::move(in_key_data));
51 for(size_t i = 0; i < m_wots_params.len(); i++)
52 {
53 adrs.set_chain_address(static_cast<uint32_t>(i));
54 chain(pub_key[i], 0, m_wots_params.wots_parameter() - 1, adrs,
55 public_seed(), hash);
56 }
57 }
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::chain
void chain(secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed, XMSS_Hash &hash)
Definition: xmss_wots_publickey.cpp:16
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:55
Botan::XMSS_WOTS_Parameters::len
size_t len() const
Definition: xmss_wots_parameters.h:89
Botan::XMSS_WOTS_Parameters::wots_parameter
size_t wots_parameter() const
Definition: xmss_wots_parameters.h:87
Botan::XMSS_WOTS_PublicKey::wots_parameters
const XMSS_WOTS_Parameters & wots_parameters() const
Definition: xmss_wots_publickey.h:229
hash
MechanismType hash
Definition: p11_mechanism.cpp:64
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

void Botan::XMSS_WOTS_PrivateKey::generate_public_key | ( | XMSS_WOTS_PublicKey & | pub_key,
|  | wots_keysig_t && | in_key_data,
|  | XMSS_Address & | adrs
| ) |  |
| inline

Algorithm 4: "WOTS_genPK" Initializes a Winternitz One Time Signature+ (WOTS+) Public Key's key_data() member, with data derived from in_key_data using the WOTS chaining function.

Parameters

  [out] | pub_key | Public key to initialize key_data() member on.
  | in_key_data | Input key material from private key used for public key generation.
  | adrs | Hash function address encoding the address of the WOTS+ key pair within a greater structure.

Definition at line 219 of file xmss_wots_privatekey.h.

References generate_public_key(), and Botan::XMSS_WOTS_PublicKey::m_hash.

222 {
223 generate_public_key(pub_key, std::forward<wots_keysig_t>(in_key_data), adrs, m_hash);
224 }
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:326
Botan::XMSS_WOTS_PrivateKey::generate_public_key
XMSS_WOTS_PublicKey generate_public_key(XMSS_Address &adrs)
Definition: xmss_wots_privatekey.cpp:32

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

const wots_keysig_t& Botan::XMSS_WOTS_PublicKey::key_data | ( |  | ) | const
| inline inherited

Definition at line 215 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

Referenced by Botan::XMSS_WOTS_PublicKey::set_key_data().

215 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

wots_keysig_t& Botan::XMSS_WOTS_PublicKey::key_data | ( |  | ) |
| inline inherited

Definition at line 217 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

217 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

size_t Botan::XMSS_WOTS_PublicKey::key_length | ( |  | ) | const
| inline override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 254 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_Parameters::estimated_strength(), and Botan::XMSS_WOTS_PublicKey::m_wots_params.

255 {
256 return m_wots_params.estimated_strength();
257 }
Botan::XMSS_WOTS_Parameters::estimated_strength
size_t estimated_strength() const
Definition: xmss_wots_parameters.h:99
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::ECDSA_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::SM2_PublicKey, and Botan::DSA_PublicKey.

Definition at line 124 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

124 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::ECDSA_PublicKey, Botan::GOST_3410_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::SM2_PublicKey, and Botan::DSA_PublicKey.

Definition at line 113 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

113 { return 1; }

Botan::XMSS_WOTS_PublicKey::operator const wots_keysig_t & | ( |  | ) | const
| inline inherited

Convert the key into the raw key data. The key becomes a length len vector of n-byte elements.

Definition at line 193 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

193 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

Botan::XMSS_WOTS_PublicKey::operator wots_keysig_t & | ( |  | ) |
| inline inherited

Convert the key into the raw key data. The key becomes a length len vector of n-byte elements.

Definition at line 199 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

199 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

bool Botan::XMSS_WOTS_PublicKey::operator!= | ( | const XMSS_WOTS_PublicKey & | key | ) |
| inline inherited

Definition at line 269 of file xmss_wots_publickey.h.

270 {
271 return !(*this == key);
272 }

bool Botan::XMSS_WOTS_PublicKey::operator== | ( | const XMSS_WOTS_PublicKey & | key | ) |
| inline inherited

Definition at line 264 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

265 {
266 return m_key == key.m_key;
267 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::operator[] | ( | size_t | i | ) |
| inline

Retrieves the i-th WOTS private key using pseudo random key (re-)generation.

Parameters

  i | Index of the key to retrieve.

Returns
  WOTS secret key.

Definition at line 140 of file xmss_wots_privatekey.h.

References at(), and Botan::XMSS_WOTS_PublicKey::m_hash.

141 {
142 return this->at(i, m_hash);
143 }
Botan::XMSS_WOTS_PrivateKey::at
wots_keysig_t at(size_t i, XMSS_Hash &hash)
Definition: xmss_wots_privatekey.h:124
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:326

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::operator[] | ( | const XMSS_Address & | adrs | ) |
| inline

Definition at line 166 of file xmss_wots_privatekey.h.

References at(), and Botan::XMSS_WOTS_PublicKey::m_hash.

167 {
168 return this->at(adrs, m_hash);
169 }
Botan::XMSS_WOTS_PrivateKey::at
wots_keysig_t at(size_t i, XMSS_Hash &hash)
Definition: xmss_wots_privatekey.h:124
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:326

const secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::operator[] | ( | size_t | i | ) | const
| inline inherited

Retrieves the i-th element out of the length len chain of n-byte elements contained in the public key.

Parameters

  i | index of the element.

Returns
  n-byte element addressed by i.

Definition at line 186 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_key.

186 { return m_key[i]; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327

AlgorithmIdentifier Botan::XMSS_WOTS_PrivateKey::pkcs8_algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented from Botan::Private_Key.

Definition at line 296 of file xmss_wots_privatekey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PrivateKey::pkcs8_algorithm_identifier().

297 {
298 throw Not_Implemented("No AlgorithmIdentifier available for XMSS-WOTS.");
299 }

secure_vector<uint8_t> Botan::XMSS_WOTS_PrivateKey::private_key_bits | ( |  | ) | const
| inline override virtual

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 301 of file xmss_wots_privatekey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PrivateKey::private_key_bits().

302 {
303 throw Not_Implemented("No PKCS8 key format defined for XMSS-WOTS.");
304 }

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:205
Botan::OCTET_STRING
Definition: asn1_obj.h:36

const secure_vector<uint8_t>& Botan::XMSS_WOTS_PrivateKey::private_seed | ( |  | ) | const
| inline

Retrieves the secret seed used to generate WOTS+ chains. The seed should be a uniformly random n-byte value.

Returns
  secret seed.

Definition at line 268 of file xmss_wots_privatekey.h.

Referenced by Botan::XMSS_PrivateKey::raw_private_key(), and set_private_seed().

269 {
270 return m_private_seed;
271 }

std::vector<uint8_t> Botan::XMSS_WOTS_PublicKey::public_key_bits | ( |  | ) | const
| inline override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 259 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits().

260 {
261 throw Not_Implemented("No key format defined for XMSS-WOTS");
262 }

const secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::public_seed | ( |  | ) | const
| inline inherited

Definition at line 201 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_public_seed.

Referenced by generate_public_key(), and Botan::XMSS_WOTS_PublicKey::set_public_seed().

201 { return m_public_seed; }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:328

secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::public_seed | ( |  | ) |
| inline inherited

Definition at line 203 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_public_seed.

203 { return m_public_seed; }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:328

void Botan::XMSS_WOTS_PublicKey::set_key_data | ( | const wots_keysig_t & | key_data | ) |
| inline inherited

Definition at line 219 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::key_data(), and Botan::XMSS_WOTS_PublicKey::m_key.

Referenced by generate_public_key(), and XMSS_WOTS_PrivateKey().

220 {
221 m_key = key_data;
222 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327
Botan::XMSS_WOTS_PublicKey::key_data
const wots_keysig_t & key_data() const
Definition: xmss_wots_publickey.h:215

void Botan::XMSS_WOTS_PublicKey::set_key_data | ( | wots_keysig_t && | key_data | ) |
| inline inherited

Definition at line 224 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::key_data(), and Botan::XMSS_WOTS_PublicKey::m_key.

225 {
226 m_key = std::move(key_data);
227 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:327
Botan::XMSS_WOTS_PublicKey::key_data
const wots_keysig_t & key_data() const
Definition: xmss_wots_publickey.h:215

void Botan::XMSS_WOTS_PrivateKey::set_private_seed | ( | const secure_vector< uint8_t > & | private_seed | ) |
| inline

Sets the secret seed used to generate WOTS+ chains. The seed should be a uniformly random n-byte value.

Parameters

  private_seed | Uniformly random n-byte value.

Definition at line 279 of file xmss_wots_privatekey.h.

References private_seed().

Referenced by Botan::XMSS_PrivateKey::XMSS_PrivateKey().

280 {
281 m_private_seed = private_seed;
282 }
Botan::XMSS_WOTS_PrivateKey::private_seed
const secure_vector< uint8_t > & private_seed() const
Definition: xmss_wots_privatekey.h:268

void Botan::XMSS_WOTS_PrivateKey::set_private_seed | ( | secure_vector< uint8_t > && | private_seed | ) |
| inline

Sets the secret seed used to generate WOTS+ chains. The seed should be a uniformly random n-byte value.

Parameters

  private_seed | Uniformly random n-byte value.

Definition at line 290 of file xmss_wots_privatekey.h.

References private_seed().

291 {
292 m_private_seed = std::move(private_seed);
293 }
Botan::XMSS_WOTS_PrivateKey::private_seed
const secure_vector< uint8_t > & private_seed() const
Definition: xmss_wots_privatekey.h:268

void Botan::XMSS_WOTS_PublicKey::set_public_seed | ( | const secure_vector< uint8_t > & | public_seed | ) |
| inline inherited

Definition at line 205 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_public_seed, and Botan::XMSS_WOTS_PublicKey::public_seed().

206 {
207 m_public_seed = public_seed;
208 }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:328
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201

void Botan::XMSS_WOTS_PublicKey::set_public_seed | ( | secure_vector< uint8_t > && | public_seed | ) |
| inline inherited

Definition at line 210 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_public_seed, and Botan::XMSS_WOTS_PublicKey::public_seed().

211 {
212 m_public_seed = std::move(public_seed);
213 }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:328
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::sign | ( | const secure_vector< uint8_t > & | msg,
|  | XMSS_Address & | adrs
| ) |  |
| inline

Algorithm 5: "WOTS_sign" Generates a signature from a private key and a message.

Parameters

  msg | A message to sign.
  adrs | An OTS hash address identifying the WOTS+ key pair used for signing.

Returns
  signature for msg.

Definition at line 236 of file xmss_wots_privatekey.h.

References Botan::XMSS_WOTS_PublicKey::m_hash.

238 {
239 return sign(msg, adrs, m_hash);
240 }
Botan::XMSS_WOTS_PrivateKey::sign
wots_keysig_t sign(const secure_vector< uint8_t > &msg, XMSS_Address &adrs)
Definition: xmss_wots_privatekey.h:236
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:326

wots_keysig_t Botan::XMSS_WOTS_PrivateKey::sign | ( | const secure_vector< uint8_t > & | msg,
|  | XMSS_Address & | adrs,
|  | XMSS_Hash & | hash
| ) |  |

Algorithm 5: "WOTS_sign" Generates a signature from a private key and a message.

This overload is used in multithreaded scenarios, where it is required to provide seperate instances of XMSS_Hash to each thread.

Parameters

  msg | A message to sign.
  adrs | An OTS hash address identifying the WOTS+ key pair used for signing.
  hash | Instance of XMSS_Hash, that may only be used by the thead executing sign.

Returns
  signature for msg.

Definition at line 60 of file xmss_wots_privatekey.cpp.

References Botan::XMSS_WOTS_Parameters::append_checksum(), at(), Botan::XMSS_WOTS_Parameters::base_w(), Botan::XMSS_WOTS_PublicKey::chain(), Botan::XMSS_WOTS_Parameters::len(), Botan::XMSS_WOTS_Parameters::len_1(), Botan::XMSS_WOTS_PublicKey::m_public_seed, Botan::XMSS_WOTS_PublicKey::m_wots_params, and Botan::XMSS_Address::set_chain_address().

64 {
65 secure_vector<uint8_t> msg_digest
66 {
67 m_wots_params.base_w(msg, m_wots_params.len_1())
68 };
69
70 m_wots_params.append_checksum(msg_digest);
71 wots_keysig_t sig(this->at(adrs, hash));
72
73 for(size_t i = 0; i < m_wots_params.len(); i++)
74 {
75 adrs.set_chain_address(static_cast<uint32_t>(i));
76 chain(sig[i], 0 , msg_digest[i], adrs, m_public_seed, hash);
77 }
78
79 return sig;
80 }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:328
Botan::XMSS_WOTS_PrivateKey::at
wots_keysig_t at(size_t i, XMSS_Hash &hash)
Definition: xmss_wots_privatekey.h:124
Botan::XMSS_WOTS_PublicKey::chain
void chain(secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed, XMSS_Hash &hash)
Definition: xmss_wots_publickey.cpp:16
Botan::XMSS_WOTS_Parameters::base_w
secure_vector< uint8_t > base_w(const secure_vector< uint8_t > &msg, size_t out_size) const
Definition: xmss_wots_parameters.cpp:90
Botan::XMSS_WOTS_Parameters::len
size_t len() const
Definition: xmss_wots_parameters.h:89
Botan::wots_keysig_t
std::vector< secure_vector< uint8_t > > wots_keysig_t
Definition: xmss_common_ops.h:21
Botan::XMSS_WOTS_Parameters::append_checksum
void append_checksum(secure_vector< uint8_t > &data)
Definition: xmss_wots_parameters.cpp:123
Botan::XMSS_WOTS_Parameters::len_1
size_t len_1() const
Definition: xmss_wots_parameters.h:91
hash
MechanismType hash
Definition: p11_mechanism.cpp:64
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 189 of file pk_keys.h.

189 { return false; }

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::BIT_STRING
Definition: asn1_obj.h:35

const XMSS_WOTS_Parameters& Botan::XMSS_WOTS_PublicKey::wots_parameters | ( |  | ) | const
| inline inherited

Definition at line 229 of file xmss_wots_publickey.h.

References Botan::XMSS_WOTS_PublicKey::m_wots_params.

Referenced by generate_public_key().

230 {
231 return m_wots_params;
232 }
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:325

## Member Data Documentation

XMSS_Hash Botan::XMSS_WOTS_PublicKey::m_hash
| protected inherited

Definition at line 326 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PublicKey::chain(), generate_public_key(), operator[](), and sign().

wots_keysig_t Botan::XMSS_WOTS_PublicKey::m_key
| protected inherited

Definition at line 327 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PublicKey::key_data(), Botan::XMSS_WOTS_PublicKey::operator const wots_keysig_t &(), Botan::XMSS_WOTS_PublicKey::operator wots_keysig_t &(), Botan::XMSS_WOTS_PublicKey::operator==(), Botan::XMSS_WOTS_PublicKey::operator[](), and Botan::XMSS_WOTS_PublicKey::set_key_data().

secure_vector<uint8_t> Botan::XMSS_WOTS_PublicKey::m_public_seed
| protected inherited

Definition at line 328 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PublicKey::public_seed(), Botan::XMSS_WOTS_PublicKey::set_public_seed(), and sign().

XMSS_WOTS_Parameters Botan::XMSS_WOTS_PublicKey::m_wots_params
| protected inherited

Definition at line 325 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PublicKey::algo_name(), at(), Botan::XMSS_WOTS_PublicKey::chain(), Botan::XMSS_WOTS_PublicKey::estimated_strength(), generate_public_key(), Botan::XMSS_WOTS_PublicKey::key_length(), sign(), and Botan::XMSS_WOTS_PublicKey::wots_parameters().

The documentation for this class was generated from the following files:

- src/lib/pubkey/xmss/xmss_wots_privatekey.h
- src/lib/pubkey/xmss/xmss_wots_privatekey.cpp